Index: boot/arch/sparc64/loader/asm.h
===================================================================
--- boot/arch/sparc64/loader/asm.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/sparc64/loader/asm.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -34,12 +34,12 @@
 #include "main.h"
 
-#define PAGE_WIDTH	14
-#define PAGE_SIZE	(1 << PAGE_WIDTH)
+#define PAGE_WIDTH  14
+#define PAGE_SIZE   (1 << PAGE_WIDTH)
 
-#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+#define BALLOC_MAX_SIZE  (128 * 1024)
 
 extern void halt(void);
 extern void jump_to_kernel(void *entry, uint64_t cfg, bootinfo_t *bootinfo,
-	unsigned int bootinfo_size) __attribute__((noreturn));
+    unsigned int bootinfo_size, uint8_t subarchitecture) __attribute__((noreturn));
 
 #endif
Index: boot/arch/sparc64/loader/main.c
===================================================================
--- boot/arch/sparc64/loader/main.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/sparc64/loader/main.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -1,5 +1,5 @@
 /*
  * Copyright (c) 2005 Martin Decky
- * Copyright (c) 2006 Jakub Jermar 
+ * Copyright (c) 2006 Jakub Jermar
  * All rights reserved.
  *
@@ -28,5 +28,5 @@
  */
 
-#include "main.h" 
+#include "main.h"
 #include <printf.h>
 #include "asm.h"
@@ -39,25 +39,24 @@
 #include <macros.h>
 #include <string.h>
-
-bootinfo_t bootinfo;
-
-component_t components[COMPONENTS];
-
-char *release = STRING(RELEASE);
+#include <memstr.h>
+
+static bootinfo_t bootinfo;
+static component_t components[COMPONENTS];
+static char *release = STRING(RELEASE);
 
 #ifdef REVISION
-	char *revision = ", revision " STRING(REVISION);
+	static char *revision = ", revision " STRING(REVISION);
 #else
-	char *revision = "";
+	static char *revision = "";
 #endif
 
 #ifdef TIMESTAMP
-	char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
+	static char *timestamp = "\nBuilt on " STRING(TIMESTAMP);
 #else
-	char *timestamp = "";
+	static char *timestamp = "";
 #endif
 
 /** UltraSPARC subarchitecture - 1 for US, 3 for US3 */
-uint8_t subarchitecture;
+static uint8_t subarchitecture;
 
 /**
@@ -65,5 +64,5 @@
  * MID_SHIFT bits to the right
  */
-uint16_t mid_mask;
+static uint16_t mid_mask;
 
 /** Print version information. */
@@ -76,11 +75,11 @@
 
 /* the lowest ID (read from the VER register) of some US3 CPU model */
-#define FIRST_US3_CPU 	0x14
+#define FIRST_US3_CPU  0x14
 
 /* the greatest ID (read from the VER register) of some US3 CPU model */
-#define LAST_US3_CPU 	0x19
+#define LAST_US3_CPU   0x19
 
 /* UltraSPARC IIIi processor implementation code */
-#define US_IIIi_CODE	0x15
+#define US_IIIi_CODE   0x15
 
 /**
@@ -91,5 +90,8 @@
 {
 	uint64_t v;
-	asm volatile ("rdpr %%ver, %0\n" : "=r" (v));
+	asm volatile (
+		"rdpr %%ver, %0\n"
+		: "=r" (v)
+	);
 	
 	v = (v << 16) >> 48;
@@ -103,7 +105,6 @@
 		subarchitecture = SUBARCH_US;
 		mid_mask = (1 << 5) - 1;
-	} else {
+	} else
 		printf("\nThis CPU is not supported by HelenOS.");
-	}
 }
 
@@ -113,26 +114,27 @@
 	void *balloc_base;
 	unsigned int top = 0;
-	int i, j;
-
+	unsigned int i;
+	unsigned int j;
+	
 	version_print();
 	
 	detect_subarchitecture();
 	init_components(components);
-
+	
 	if (!ofw_get_physmem_start(&bootinfo.physmem_start)) {
 		printf("Error: unable to get start of physical memory.\n");
 		halt();
 	}
-
+	
 	if (!ofw_memmap(&bootinfo.memmap)) {
 		printf("Error: unable to get memory map, halting.\n");
 		halt();
 	}
-
+	
 	if (bootinfo.memmap.total == 0) {
 		printf("Error: no memory detected, halting.\n");
 		halt();
 	}
-
+	
 	/*
 	 * SILO for some reason adds 0x400000 and subtracts
@@ -143,19 +145,17 @@
 		silo_ramdisk_image += bootinfo.physmem_start;
 		silo_ramdisk_image -= 0x400000;
-		/* Install 1:1 mapping for the ramdisk. */
-		if (ofw_map((void *)((uintptr_t) silo_ramdisk_image),
-		    (void *)((uintptr_t) silo_ramdisk_image),
+		
+		/* Install 1:1 mapping for the RAM disk. */
+		if (ofw_map((void *) ((uintptr_t) silo_ramdisk_image),
+		    (void *) ((uintptr_t) silo_ramdisk_image),
 		    silo_ramdisk_size, -1) != 0) {
-			printf("Failed to map ramdisk.\n");
+			printf("Failed to map RAM disk.\n");
 			halt();
 		}
 	}
 	
-	printf("\nSystem info\n");
-	printf(" memory: %dM starting at %P\n",
+	printf("\nMemory statistics (total %d MB, starting at %P)\n",
 	    bootinfo.memmap.total >> 20, bootinfo.physmem_start);
-
-	printf("\nMemory statistics\n");
-	printf(" kernel entry point at %P\n", KERNEL_VIRTUAL_ADDRESS);
+	printf(" %P: kernel entry point\n", KERNEL_VIRTUAL_ADDRESS);
 	printf(" %P: boot info structure\n", &bootinfo);
 	
@@ -176,4 +176,5 @@
 				break;
 			}
+			
 			bootinfo.taskmap.tasks[bootinfo.taskmap.count].addr =
 			    base + top;
@@ -187,13 +188,15 @@
 		top += components[i].size;
 	}
-
-	j = bootinfo.taskmap.count - 1;	/* do not consider ramdisk */
-
+	
+	/* Do not consider RAM disk */
+	j = bootinfo.taskmap.count - 1;
+	
 	if (silo_ramdisk_image) {
-		/* Treat the ramdisk as the last bootinfo task. */
+		/* Treat the RAM disk as the last bootinfo task. */
 		if (bootinfo.taskmap.count == TASKMAP_MAX_RECORDS) {
-			printf("Skipping ramdisk.\n");
+			printf("Skipping RAM disk.\n");
 			goto skip_ramdisk;
 		}
+		
 		top = ALIGN_UP(top, PAGE_SIZE);
 		bootinfo.taskmap.tasks[bootinfo.taskmap.count].addr = 
@@ -202,5 +205,6 @@
 		    silo_ramdisk_size;
 		bootinfo.taskmap.count++;
-		printf("\nCopying ramdisk...");
+		printf("\nCopying RAM disk...");
+		
 		/*
 		 * Claim and map the whole ramdisk as it may exceed the area
@@ -210,11 +214,12 @@
 		(void) ofw_map(bootinfo.physmem_start + base + top, base + top,
 		    silo_ramdisk_size, -1);
-		memmove(base + top, (void *)((uintptr_t)silo_ramdisk_image),
+		memmove(base + top, (void *) ((uintptr_t) silo_ramdisk_image),
 		    silo_ramdisk_size);
+		
 		printf("done.\n");
 		top += silo_ramdisk_size;
 	}
 skip_ramdisk:
-
+	
 	/*
 	 * Now we can proceed to copy the components. We do it in reverse order
@@ -222,8 +227,8 @@
 	 * with base.
 	 */
-	printf("\nCopying bootinfo tasks\n");
+	printf("\nCopying tasks...");
 	for (i = COMPONENTS - 1; i > 0; i--, j--) {
-		printf(" %s...", components[i].name);
-
+		printf("%s ", components[i].name);
+		
 		/*
 		 * At this point, we claim the physical memory that we are
@@ -240,10 +245,11 @@
 		    bootinfo.taskmap.tasks[j].addr,
 		    ALIGN_UP(components[i].size, PAGE_SIZE));
-		    
-		memcpy((void *)bootinfo.taskmap.tasks[j].addr,
+		
+		memcpy((void *) bootinfo.taskmap.tasks[j].addr,
 		    components[i].start, components[i].size);
-		printf("done.\n");
-	}
-
+		
+	}
+	printf(".\n");
+	
 	printf("\nCopying kernel...");
 	(void) ofw_claim_phys(bootinfo.physmem_start + base,
@@ -251,5 +257,5 @@
 	memcpy(base, components[0].start, components[0].size);
 	printf("done.\n");
-
+	
 	/*
 	 * Claim and map the physical memory for the boot allocator.
@@ -261,22 +267,23 @@
 	(void) ofw_map(bootinfo.physmem_start + balloc_base, balloc_base,
 	    BALLOC_MAX_SIZE, -1);
-	balloc_init(&bootinfo.ballocs, (uintptr_t)balloc_base);
-
+	balloc_init(&bootinfo.ballocs, (uintptr_t) balloc_base,
+	    (uintptr_t) balloc_base);
+	
 	printf("\nCanonizing OpenFirmware device tree...");
 	bootinfo.ofw_root = ofw_tree_build();
 	printf("done.\n");
-
+	
 #ifdef CONFIG_AP
 	printf("\nChecking for secondary processors...");
-	if (!ofw_cpu())
+	if (!ofw_cpu(mid_mask, bootinfo.physmem_start))
 		printf("Error: unable to get CPU properties\n");
 	printf("done.\n");
 #endif
-
+	
 	ofw_setup_palette();
-
+	
 	printf("\nBooting the kernel...\n");
 	jump_to_kernel((void *) KERNEL_VIRTUAL_ADDRESS,
 	    bootinfo.physmem_start | BSP_PROCESSOR, &bootinfo,
-	    sizeof(bootinfo));
+	    sizeof(bootinfo), subarchitecture);
 }
Index: boot/arch/sparc64/loader/main.h
===================================================================
--- boot/arch/sparc64/loader/main.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/sparc64/loader/main.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -35,16 +35,16 @@
 #include <types.h>
 
-#define KERNEL_VIRTUAL_ADDRESS 0x400000
+#define KERNEL_VIRTUAL_ADDRESS  0x400000
 
-#define TASKMAP_MAX_RECORDS 32
+#define TASKMAP_MAX_RECORDS  32
 
 /** Size of buffer for storing task name in task_t. */
-#define BOOTINFO_TASK_NAME_BUFLEN 32
+#define BOOTINFO_TASK_NAME_BUFLEN  32
 
-#define BSP_PROCESSOR	1
-#define AP_PROCESSOR	0
+#define BSP_PROCESSOR  1
+#define AP_PROCESSOR   0
 
-#define SUBARCH_US	1
-#define SUBARCH_US3	3
+#define SUBARCH_US   1
+#define SUBARCH_US3  3
 
 typedef struct {
@@ -70,6 +70,4 @@
 extern uint32_t silo_ramdisk_size;
 
-extern bootinfo_t bootinfo;
-
 extern void start(void);
 extern void bootstrap(void);
Index: boot/arch/sparc64/loader/ofwarch.c
===================================================================
--- boot/arch/sparc64/loader/ofwarch.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/sparc64/loader/ofwarch.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -30,5 +30,5 @@
 /**
  * @file
- * @brief	Architecture dependent parts of OpenFirmware interface.
+ * @brief Architecture dependent parts of OpenFirmware interface.
  */
 
@@ -40,8 +40,4 @@
 #include "main.h"
 #include "asm.h"
-
-/* these tho variables will be set by the detect_subarchitecture function */
-extern uint8_t subarchitecture;
-extern uint16_t mid_mask;
 
 void write(const char *str, const int len)
@@ -65,18 +61,23 @@
  * except for the current CPU.
  *
- * @param child		The first child of the OFW tree node whose children
- * 			represent CPUs to be woken up.
- * @param current_mid	MID of the current CPU, the current CPU will
- *			(of course) not be woken up.
- * @return		Number of CPUs which have the same parent node as
- * 			"child".
+ * @param child         The first child of the OFW tree node whose children
+ *                      represent CPUs to be woken up.
+ * @param current_mid   MID of the current CPU, the current CPU will
+ *                      (of course) not be woken up.
+ * @param physmem_start Starting address of the physical memory.
+ *
+ * @return Number of CPUs which have the same parent node as
+ *         "child".
+ *
  */
-static int wake_cpus_in_node(phandle child, uint64_t current_mid)
+static int wake_cpus_in_node(phandle child, uint64_t current_mid,
+    uintptr_t physmem_start)
 {
 	int cpus;
-	char type_name[BUF_SIZE];
 	
-	for (cpus = 0; child != 0 && child != -1;
+	for (cpus = 0; (child != 0) && (child != -1);
 	    child = ofw_get_peer_node(child), cpus++) {
+		char type_name[BUF_SIZE];
+		
 		if (ofw_get_property(child, "device_type", type_name,
 		    sizeof(type_name)) > 0) {
@@ -88,13 +89,9 @@
 				 * "cpuid" for US-IV
 				 */
-				if (ofw_get_property(
-				    child, "upa-portid",
-				    &mid, sizeof(mid)) <= 0
-				    && ofw_get_property(child, "portid",
-				    &mid, sizeof(mid)) <= 0
-				    && ofw_get_property(child, "cpuid",
-				    &mid, sizeof(mid)) <= 0)
+				if ((ofw_get_property(child, "upa-portid", &mid, sizeof(mid)) <= 0)
+				    && (ofw_get_property(child, "portid", &mid, sizeof(mid)) <= 0)
+				    && (ofw_get_property(child, "cpuid", &mid, sizeof(mid)) <= 0))
 					continue;
-					
+				
 				if (current_mid != mid) {
 					/*
@@ -103,11 +100,10 @@
 					(void) ofw_call("SUNW,start-cpu", 3, 1,
 					    NULL, child, KERNEL_VIRTUAL_ADDRESS,
-					    bootinfo.physmem_start |
-					    AP_PROCESSOR);
+					    physmem_start | AP_PROCESSOR);
 				}
 			}
 		}
 	}
-
+	
 	return cpus;
 }
@@ -116,39 +112,35 @@
  * Finds out the current CPU's MID and wakes up all AP processors.
  */
-int ofw_cpu(void)
+int ofw_cpu(uint16_t mid_mask, uintptr_t physmem_start)
 {
-	int cpus;
-	phandle node;
-	phandle subnode;
-	phandle cpus_parent;
-	phandle cmp;
-	char name[BUF_SIZE];
-
-	/* get the current CPU MID */
+	/* Get the current CPU MID */
 	uint64_t current_mid;
 	
-	asm volatile ("ldxa [%1] %2, %0\n"
-	    : "=r" (current_mid)
-	    : "r" (0), "i" (ASI_ICBUS_CONFIG));
+	asm volatile (
+		"ldxa [%1] %2, %0\n"
+		: "=r" (current_mid)
+		: "r" (0), "i" (ASI_ICBUS_CONFIG)
+	);
+	
 	current_mid >>= ICBUS_CONFIG_MID_SHIFT;
-
 	current_mid &= mid_mask;
-
-	/* wake up CPUs */
 	
-	cpus_parent = ofw_find_device("/ssm@0,0");
-	if (cpus_parent == 0 || cpus_parent == -1) {
+	/* Wake up the CPUs */
+	
+	phandle cpus_parent = ofw_find_device("/ssm@0,0");
+	if ((cpus_parent == 0) || (cpus_parent == -1))
 		cpus_parent = ofw_find_device("/");
-	}
-
-	node = ofw_get_child_node(cpus_parent);
-	cpus = wake_cpus_in_node(node, current_mid);
-	while (node != 0 && node != -1) {
+	
+	phandle node = ofw_get_child_node(cpus_parent);
+	int cpus = wake_cpus_in_node(node, current_mid, physmem_start);
+	while ((node != 0) && (node != -1)) {
+		char name[BUF_SIZE];
+		
 		if (ofw_get_property(node, "name", name,
-			sizeof(name)) > 0) {
+		    sizeof(name)) > 0) {
 			if (strcmp(name, "cmp") == 0) {
-				subnode = ofw_get_child_node(node);
+				phandle subnode = ofw_get_child_node(node);
 				cpus += wake_cpus_in_node(subnode,
-					current_mid);
+					current_mid, physmem_start);
 			}
 		}
@@ -157,23 +149,21 @@
 	
 	return cpus;
-	
 }
 
 /** Get physical memory starting address.
  *
- * @param start		Pointer to variable where the physical memory starting
- *			address will be stored.
+ * @param start Pointer to variable where the physical memory starting
+ *              address will be stored.
  *
- * @return		Non-zero on succes, zero on failure.
+ * @return Non-zero on succes, zero on failure.
+ *
  */
 int ofw_get_physmem_start(uintptr_t *start)
 {
 	uint32_t memreg[4];
-
 	if (ofw_get_property(ofw_memory, "reg", &memreg, sizeof(memreg)) <= 0)
 		return 0;
-
+	
 	*start = (((uint64_t) memreg[0]) << 32) | memreg[1];
 	return 1;
 }
-
Index: boot/arch/sparc64/loader/ofwarch.h
===================================================================
--- boot/arch/sparc64/loader/ofwarch.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/arch/sparc64/loader/ofwarch.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -33,9 +33,9 @@
 #include "types.h"
 
-#define OFW_ADDRESS_CELLS	2
-#define OFW_SIZE_CELLS		2
+#define OFW_ADDRESS_CELLS  2
+#define OFW_SIZE_CELLS     2
 
-extern int ofw_cpu(void);
-extern int ofw_get_physmem_start(uintptr_t *start); 
+extern int ofw_cpu(uint16_t mid_mask, uintptr_t physmem_start);
+extern int ofw_get_physmem_start(uintptr_t *start);
 
 #endif
Index: boot/genarch/balloc.c
===================================================================
--- boot/genarch/balloc.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/genarch/balloc.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -28,13 +28,16 @@
 
 #include <balloc.h>
+#include <asm.h>
 #include <types.h>
 #include <align.h>
 
 static ballocs_t *ballocs;
+static uintptr_t phys_base;
 
-void balloc_init(ballocs_t *b, uintptr_t base)
+void balloc_init(ballocs_t *ball, uintptr_t base, uintptr_t kernel_base)
 {
-	ballocs = b;
-	ballocs->base = base;
+	ballocs = ball;
+	phys_base = base;
+	ballocs->base = kernel_base;
 	ballocs->size = 0;
 }
@@ -42,16 +45,19 @@
 void *balloc(size_t size, size_t alignment)
 {
-	uintptr_t addr;
-
 	/* Enforce minimal alignment. */
 	alignment = ALIGN_UP(alignment, 4);
 	
-	addr = ballocs->base + ALIGN_UP(ballocs->size, alignment);
-
+	uintptr_t addr = phys_base + ALIGN_UP(ballocs->size, alignment);
+	
 	if (ALIGN_UP(ballocs->size, alignment) + size > BALLOC_MAX_SIZE)
 		return NULL;
-		
+	
 	ballocs->size = ALIGN_UP(ballocs->size, alignment) + size;
 	
 	return (void *) addr;
 }
+
+void *balloc_rebase(void *ptr)
+{
+	return (void *) ((uintptr_t) ptr - phys_base + ballocs->base);
+}
Index: boot/genarch/balloc.h
===================================================================
--- boot/genarch/balloc.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/genarch/balloc.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -32,6 +32,4 @@
 #include <types.h>
 
-#define BALLOC_MAX_SIZE		(128 * 1024)
-
 typedef struct {
 	uintptr_t base;
@@ -39,6 +37,7 @@
 } ballocs_t;
 
-extern void balloc_init(ballocs_t *b, uintptr_t base);
+extern void balloc_init(ballocs_t *ball, uintptr_t base, uintptr_t kernel_base);
 extern void *balloc(size_t size, size_t alignment);
+extern void *balloc_rebase(void *ptr);
 
 #endif
Index: boot/genarch/ofw.c
===================================================================
--- boot/genarch/ofw.c	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/genarch/ofw.c	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -33,4 +33,9 @@
 #include <types.h>
 
+#define RED(i)    (((i) >> 5) & ((1 << 3) - 1))
+#define GREEN(i)  (((i) >> 3) & ((1 << 2) - 1))
+#define BLUE(i)   ((i) & ((1 << 3) - 1))
+#define CLIP(i)   ((i) <= 255 ? (i) : 255)
+
 uintptr_t ofw_cif;
 
@@ -85,12 +90,13 @@
 /** Perform a call to OpenFirmware client interface.
  *
- * @param service	String identifying the service requested.
- * @param nargs		Number of input arguments.
- * @param nret		Number of output arguments. This includes the return
- * 			value.
- * @param rets		Buffer for output arguments or NULL. The buffer must
- * 			accommodate nret - 1 items.
- *
- * @return		Return value returned by the client interface.
+ * @param service String identifying the service requested.
+ * @param nargs   Number of input arguments.
+ * @param nret    Number of output arguments. This includes the return
+ *                value.
+ * @param rets    Buffer for output arguments or NULL. The buffer must
+ *                accommodate nret - 1 items.
+ *
+ * @return Return value returned by the client interface.
+ *
  */
 unsigned long
@@ -221,5 +227,5 @@
 }
 
-void *ofw_claim_virt(const void *virt, const int len)
+void *ofw_claim_virt(const void *virt, const unsigned int len)
 {
 	ofw_arg_t retaddr;
@@ -234,41 +240,54 @@
 }
 
-void *ofw_claim_phys(const void *phys, const int len)
-{
-	ofw_arg_t retaddr[2];
-	int shift;
-
+static void *ofw_claim_phys_internal(const void *phys, const unsigned int len, const unsigned int alignment)
+{
+	/*
+	 * Note that the return value check will help
+	 * us to discover conflicts between OpenFirmware
+	 * allocations and our use of physical memory.
+	 * It is better to detect collisions here
+	 * than to cope with weird errors later.
+	 *
+	 * So this is really not to make the loader
+	 * more generic; it is here for debugging
+	 * purposes.
+	 */
+	
 	if (sizeof(unative_t) == 8) {
-		shift = 32;
+		ofw_arg_t retaddr[2];
+		int shift = 32;
+		
 		if (ofw_call("call-method", 6, 3, retaddr, "claim",
-		    ofw_memory_prop, 0, len, ((uintptr_t) phys) >> shift,
+		    ofw_memory_prop, alignment, len, ((uintptr_t) phys) >> shift,
 		    ((uintptr_t) phys) & ((uint32_t) -1)) != 0) {
-			/*
-			 * Note that this will help us to discover
-			 * conflicts between OpenFirmware allocations
-			 * and our use of physical memory.
-			 * It is better to detect collisions here
-			 * than to cope with weird errors later.
-			 *
-			 * So this is really not to make the loader
-			 * more generic; it is here for debugging
-			 * purposes.
-			 */
 			puts("Error: memory method claim() failed, halting.\n");
 			halt();
 		}
+		
+		return (void *) ((retaddr[0] << shift) | retaddr[1]);
 	} else {
-		shift = 0;
-		/*
-		 * FIXME: the number of arguments is probably different...
-		 */
-		puts("Error: 32-bit ofw_claim_phys not implemented.\n");
-		halt();
-	}
-
-	return (void *) ((retaddr[0] << shift) | retaddr[1]);
-}
-
-int ofw_map(const void *phys, const void *virt, const int size, const int mode)
+		ofw_arg_t retaddr[1];
+		
+		if (ofw_call("call-method", 5, 2, retaddr, "claim",
+		    ofw_memory_prop, alignment, len, (uintptr_t) phys) != 0) {
+			puts("Error: memory method claim() failed, halting.\n");
+			halt();
+		}
+		
+		return (void *) retaddr[0];
+	}
+}
+
+void *ofw_claim_phys(const void *phys, const unsigned int len)
+{
+	return ofw_claim_phys_internal(phys, len, 0);
+}
+
+void *ofw_claim_phys_any(const unsigned int len, const unsigned int alignment)
+{
+	return ofw_claim_phys_internal(NULL, len, alignment);
+}
+
+int ofw_map(const void *phys, const void *virt, const unsigned int size, const int mode)
 {
 	uintptr_t phys_hi, phys_lo;
@@ -314,9 +333,9 @@
 
 		/*
- 		 * This is a hot fix of the issue which occurs on machines
- 		 * where there are holes in the physical memory (such as
- 		 * SunBlade 1500). Should we detect a hole in the physical
- 		 * memory, we will ignore any memory detected behind
- 		 * the hole and pretend the hole does not exist.
+		 * This is a hot fix of the issue which occurs on machines
+		 * where there are holes in the physical memory (such as
+		 * SunBlade 1500). Should we detect a hole in the physical
+		 * memory, we will ignore any memory detected behind
+		 * the hole and pretend the hole does not exist.
 		 */
 		if ((map->count > 0) && (map->zones[map->count - 1].start +
@@ -335,48 +354,4 @@
 }
 
-int ofw_screen(screen_t *screen)
-{
-	char device_name[BUF_SIZE];
-	uint32_t virtaddr;
-	
-	if (ofw_get_property(ofw_aliases, "screen", device_name,
-	    sizeof(device_name)) <= 0)
-		return false;
-	
-	phandle device = ofw_find_device(device_name);
-	if (device == -1)
-		return false;
-	
-	if (ofw_get_property(device, "address", &virtaddr,
-	    sizeof(virtaddr)) <= 0)
-		return false;
-
-	screen->addr = (void *) ((uintptr_t) virtaddr);
-
-	if (ofw_get_property(device, "width", &screen->width,
-	    sizeof(screen->width)) <= 0)
-		return false;
-	
-	if (ofw_get_property(device, "height", &screen->height,
-	    sizeof(screen->height)) <= 0)
-		return false;
-	
-	if (ofw_get_property(device, "depth", &screen->bpp,
-	    sizeof(screen->bpp)) <= 0)
-		return false;
-	
-	if (ofw_get_property(device, "linebytes", &screen->scanline,
-	    sizeof(screen->scanline)) <= 0)
-		return false;
-	
-	return true;
-}
-
-#define RED(i)    (((i) >> 5) & ((1 << 3) - 1))
-#define GREEN(i)  (((i) >> 3) & ((1 << 2) - 1))
-#define BLUE(i)   ((i) & ((1 << 3) - 1))
-#define CLIP(i)   ((i) <= 255 ? (i) : 255)
-
-
 /**
  * Sets up the palette for the 8-bit color depth configuration so that the
@@ -392,10 +367,10 @@
 	char device_name[BUF_SIZE];
 	
-	/* resolve alias */
+	/* Resolve alias */
 	if (ofw_get_property(ofw_aliases, "screen", device_name,
 	    sizeof(device_name)) <= 0)
 		return false;
 	
-	/* for depth greater than 8 it makes no sense to set up the palette */
+	/* For depth greater than 8 it makes no sense to set up the palette */
 	uint32_t depth;
 	phandle device = ofw_find_device(device_name);
@@ -407,10 +382,10 @@
 		return false;
 	
-	/* required in order to be able to make a method call */
+	/* Required in order to be able to make a method call */
 	ihandle screen = ofw_open(device_name);
 	if (screen == -1)
 		return false;
 	
-	/* setup the palette so that the (inverted) 3:2:3 scheme is usable */
+	/* Setup the palette so that the (inverted) 3:2:3 scheme is usable */
 	unsigned int i;
 	for (i = 0; i < 256; i++)
Index: boot/genarch/ofw.h
===================================================================
--- boot/genarch/ofw.h	(revision 207e208e62266d2670cc05533ded75ef5cccb345)
+++ boot/genarch/ofw.h	(revision bc7d44c8c94c3e6939ba5054dd1878bd7e3674f7)
@@ -33,9 +33,9 @@
 #include <stdarg.h>
 
-#define BUF_SIZE		1024
+#define BUF_SIZE  1024
 
-#define MEMMAP_MAX_RECORDS 	32
+#define MEMMAP_MAX_RECORDS  32
 
-#define MAX_OFW_ARGS            12
+#define MAX_OFW_ARGS  12
 
 typedef unative_t ofw_arg_t;
@@ -47,8 +47,8 @@
  */
 typedef struct {
-	ofw_arg_t service;		/**< Command name. */
-	ofw_arg_t nargs;		/**< Number of in arguments. */
-	ofw_arg_t nret;			/**< Number of out arguments. */
-	ofw_arg_t args[MAX_OFW_ARGS];	/**< List of arguments. */
+	ofw_arg_t service;             /**< Command name. */
+	ofw_arg_t nargs;               /**< Number of in arguments. */
+	ofw_arg_t nret;                /**< Number of out arguments. */
+	ofw_arg_t args[MAX_OFW_ARGS];  /**< List of arguments. */
 } ofw_args_t;
 
@@ -63,17 +63,4 @@
 	memzone_t zones[MEMMAP_MAX_RECORDS];
 } memmap_t;
-
-typedef struct {
-	void *addr;
-	uint32_t width;
-	uint32_t height;
-	uint32_t bpp;
-	uint32_t scanline;
-} screen_t;
-
-typedef struct {
-	void *addr;
-	uint32_t size;
-} macio_t;
 
 typedef struct {
@@ -118,10 +105,9 @@
 extern void *ofw_translate(const void *virt);
 extern int ofw_translate_failed(ofw_arg_t flag);
-extern void *ofw_claim_virt(const void *virt, const int len);
-extern void *ofw_claim_phys(const void *virt, const int len);
-extern int ofw_map(const void *phys, const void *virt, const int size, const int mode);
+extern void *ofw_claim_virt(const void *virt, const unsigned int len);
+extern void *ofw_claim_phys(const void *virt, const unsigned int len);
+extern void *ofw_claim_phys_any(const unsigned int len, const unsigned int alignment);
+extern int ofw_map(const void *phys, const void *virt, const unsigned int size, const int mode);
 extern int ofw_memmap(memmap_t *map);
-extern int ofw_screen(screen_t *screen);
-extern int ofw_macio(macio_t *macio);
 extern int ofw_setup_palette(void);
 extern void ofw_quiesce(void);
